﻿var userSettings = new cSettings();
var updateTimerId = null;
var bNeedUpdate = true;

var towns = new Array(['Таганрог', '34720'], ['Амстердам', '6240'], ['Анапа', '37001'], ['Анталия', '17300'], ['Архангельск', '22550'], ['Астана', '35188'], ['Астрахань', '34880'], ['Афины', '16701'], ['Ашхабад', '38880'], ['Баку', '37850'], ['Бангкок', '48454'], ['Белгород', '34214'], ['Белек', '17301'], ['Берлин', '10381'], ['Бишкек', '38353'], ['Бодрум', '17290'], ['Брюссель', '6451'], ['Будапешт', '12839'], ['Будва', '13457'], ['Вашингтон', '72403'], ['Вена', '11034'], ['Вильнюс', '26730'], ['Владивосток', '31960'], ['Владимир', '27532'], ['Волгоград', '34560'], ['Воронеж', '34122'], ['Гоа', '43192'], ['Дели', '42181'], ['Донецк', '34519'], ['Дубаи', '41194'], ['Дублин', '3969'], ['Душанбе', '38836'], ['Екатеринбург', '28440'], ['Ереван', '37789'], ['Женева', '6700'], ['Загреб', '14236'], ['Ибица', '8373'], ['Иваново', '27347'], ['Иерусалим', '40184'], ['Иркутск', '30710'], ['Кадошкино', '27861'], ['Казань', '27595'], ['Каир', '62366'], ['Калининград', '26702'], ['Канны', '7684'], ['Кемер', '17299'], ['Киев', '33345'], ['Киров', '27196'], ['Кишинев', '33815'], ['Кр. Поляна', '37107'], ['Краснодар', '34929'], ['Красноярск', '29574'], ['Куршевель', '99911'], ['Елец', '27928'], ['Липецк', '4437'], ['Мармарис', '17298'], ['Мехико', '76680'], ['Минск', '26850'], ['Москва', '27612'], ['Мурманск', '22113'], ['Н. Новгород', '27553'], ['Новосибирск', '29634'], ['Нью-Йорк', '72503'], ['Омск', '28698'], ['Оренбург', '35121'], ['Париж', '7149'], ['Пекин', '54511'], ['Пермь', '28225'], ['Прага', '11518'], ['Рига', '26422'], ['Рим', '16235'], ['Ростов-на-Дону', '34731'], ['Самара', '28900'], ['Саранск', '27760'], ['С-Петербург', '26063'], ['Саратов', '34172'], ['Севастополь', '33991'], ['Сеул', '47108'], ['Сиде', '17302'], ['София', '15614'], ['Сочи', '37099'], ['Стамбул', '17059'], ['Таллин', '26038'], ['Тамбов', '27947'], ['Ташкент', '38457'], ['Тбилиси', '37549'], ['Тель-Ави', '40176'], ['Тиват', '13458'], ['Токио', '47662'], ['Томск', '29430'], ['Туапсе', '37018'], ['Тюмень', '28367'], ['Ульяновск', '27786'], ['Уфа', '28722'], ['Франкфурт', '10637'], ['Хабаровск', '31735'], ['Хельсинки', '2974'], ['Чебоксары', '27581'], ['Чегет', '99343'], ['Челябинск', '28642'], ['Чита', '30758'], ['Шарм-эль-Шейх', '62460'], ['Эльбрус', '99344']);

var update_txt = new Array('Нет', '1 раз в день', '2 раза в день', '3 раза в день');
var noResults = 'Город не найден';

function cSettings() {
	
	this.updateIndex = 0;
	this.cityIndex = 0; //Таганрог
	this.xmlText = "";	
	
	this.tempIndex = 0;
	this.tempIndex2 = 0;
	
}
	
cSettings.prototype.loadUserData = function() {
	var updateKey;								
	var cityKey;				
	var xmlKey;
		
	if(window.widget) 
	{
		updateKey = widget.preferenceForKey("UPDATE");								
		cityKey   = widget.preferenceForKey("CITY");				
		xmlKey    = widget.preferenceForKey("XMLDATA");
			
		if (!updateKey)   { this.updateIndex = 0;   } else { this.updateIndex = Number(updateKey);  }
        if (!cityKey) { this.cityIndex = 73; } else { this.cityIndex = Number(cityKey); }
        if (!xmlKey) { bNeedUpdate = true; this.xmlText = ""; } else { bNeedUpdate = false; this.xmlText = xmlKey; }
			
	}	
}	
	
cSettings.prototype.autoUpdate = function() {
	clearTimeout(updateTimerId);
	updateTimerId = null;	
	LoadXMLWeatherForecast();		
}
	
cSettings.prototype.SetUpdateTimer = function(){
	clearTimeout(updateTimerId);
	updateTimerId = null;	
	    
	if (this.updateIndex == 0) {	
		    return;
	} else {
			var today = new Date();	
			var timeSet = (today.getHours()) * 3600 + (today.getMinutes()) * 60 + today.getSeconds();
			
			if (this.updateIndex == 1) {// 09.00
				if (timeSet<32401) {
					timeSet = 32400 - timeSet;		
					updateTimerId = setTimeout(this.autoUpdate, timeSet * 1000);					
				} else {
					timeSet = 86400 - (timeSet - 32400);		
					updateTimerId = setTimeout(this.autoUpdate, timeSet * 1000);									
				}				
			} else if (this.updateIndex == 2) {	//09:00 and 15:00			
				if (timeSet < 32401) {
					timeSet = 32400 - timeSet;		
					updateTimerId = setTimeout(this.autoUpdate, timeSet * 1000);					
				} else if (timeSet > 32400 && timeSet < 54001) {
					timeSet = 54000 - timeSet;		
					updateTimerId = setTimeout(this.autoUpdate, timeSet * 1000);									
				} else{										
					timeSet = 86400 - (timeSet - 32400);	
					updateTimerId = setTimeout(this.autoUpdate, timeSet * 1000);
				}				
	        } else if (this.updateIndex == 3) { // 09:00, 14:00 and 18:00			
				if (timeSet < 32401) {	//09:00					    
					timeSet = 32400 - timeSet;	
					updateTimerId = setTimeout(this.autoUpdate, timeSet * 1000);
				} else if (timeSet > 32400 && timeSet < 50401) {	// 14:00:00
					timeSet = 50400 - timeSet;
					updateTimerId = setTimeout(this.autoUpdate, timeSet * 1000);
				} else if (timeSet > 50400 && timeSet < 64801) {	// 18:00:00
					timeSet = 64800 - timeSet;
					updateTimerId = setTimeout(this.autoUpdate, timeSet * 1000);
				} else {										    
					timeSet = 86400 - (timeSet - 32400);	
					updateTimerId = setTimeout(this.autoUpdate, timeSet * 1000);
				}				
		   }
	}
		
}
	
cSettings.prototype.saveAllUserData = function(){		
	if(window.widget) 
	{
		widget.setPreferenceForKey(this.updateIndex, "UPDATE");	
		widget.setPreferenceForKey(this.cityIndex, "CITY");	
		widget.setPreferenceForKey(this.xmlText, "XMLDATA");		
	}
}

cSettings.prototype.saveXmlData = function(xml){	
    this.xmlText = xml;
	if(window.widget) 
	{		
		widget.setPreferenceForKey(this.xmlText, "XMLDATA");		
	}
}

cSettings.prototype.initUpdatePeriod = function() {
	document.getElementById('tUpdateSettings').rows[0].style.color = "#000000";
	document.getElementById('tUpdateSettings').rows[1].style.color = "#000000";
	document.getElementById('tUpdateSettings').rows[2].style.color = "#000000";
	document.getElementById('tUpdateSettings').rows[3].style.color = "#000000";
	document.getElementById('tUpdateSettings').rows[this.updateIndex].style.color = "#FFFFFF";
	document.getElementById('tUpdateSettings').rows[this.updateIndex].style.backgroundImage="url(images/cursor2.png)";
	this.tempIndex = this.updateIndex;	
}
	
cSettings.prototype.setUpdateIndex = function(sel) {	
	document.getElementById('tUpdateSettings').rows[this.tempIndex].style.backgroundImage = "none";
	document.getElementById('tUpdateSettings').rows[this.tempIndex].style.color = "#000000";		
	document.getElementById('tUpdateSettings').rows[sel].style.backgroundImage="url(images/cursor2.png)";	
	document.getElementById('tUpdateSettings').rows[sel].style.color = "#FFFFFF";		
	this.tempIndex = sel;	
}

cSettings.prototype.saveUpdatePeriod = function(){
	if (this.tempIndex != this.updateIndex) {
		this.updateIndex = this.tempIndex;
		if(window.widget) widget.setPreferenceForKey(this.updateIndex, "UPDATE");			
	}
}

cSettings.prototype.initCityList = function() {
	document.getElementById('tCityList').rows[this.cityIndex].style.backgroundImage="url(images/cursor.png)";
	this.tempIndex2 = this.cityIndex;
}

cSettings.prototype.setCityListCursor = function(sel) {
	document.getElementById('tCityList').rows[this.tempIndex2].style.backgroundImage = "none";
	document.getElementById('tCityList').rows[sel].style.backgroundImage="url(images/cursor.png)";	
	this.tempIndex2 = sel;	
}

cSettings.prototype.saveCityIndex = function() {	
	if (this.cityIndex != this.tempIndex2) {	
		this.cityIndex = this.tempIndex2;
		bNeedUpdate = true;
		if(window.widget) widget.setPreferenceForKey(this.cityIndex, "CITY");				
	}	
}
