var y, offsetHeight, cityListHeight;
var scrollbarPos, scrollbarRatio;
var idleW = 240, idleH = 175;
var settW = 196, settH = 197;
var cityW = 223, cityH = 283;


function init() {
	bNeedUpdate = true;
	bUpdating = false;
	userSettings.loadUserData();		
	var html = "<table id='tCityList' cellpadding='0' cellspacing='0' width='100%'>";
	
	for (var i=0; i<towns.length; i++) {
	    html += "<tr><td height='30' class='city_List' onClick='javascript:userSettings.setCityListCursor("+i+");'>"
		+towns[i][0]+"</td></tr>";			
	}		
	html +="</table>";
	cityList.innerHTML = html;	
	cityListHeight = towns.length*30;
	offsetHeight = 150 - cityListHeight;			
	scrollbarPos = 0;
	scrollbarRatio = 118/cityListHeight;	
	y=0;
	userSettings.initCityList();	
	LoadWeatherForecast();			
}

function Reload() {	
	LoadXMLWeatherForecast();			
}

function showPopup(id, x, y)
{
	try
	{
		document.getElementById(id).style.display 	  = 'block';
    	document.getElementById(id).style.paddingLeft = x+'px';
	    document.getElementById(id).style.paddingTop  = y+'px';
	}
	catch(e) {}	
}

function hidePopup(id)
{		
	try 
	{
		document.getElementById(id).style.display = 'none';
	}
	catch(e) {}	
}

function gotoSettings() {
	if (bUpdating) return;

    document.getElementById('city_name').innerHTML = towns[userSettings.cityIndex][0];
	document.getElementById('update_period').innerHTML = update_txt[userSettings.updateIndex];		
	document.getElementById('idle').style.display = 'none';
	document.getElementById('settings').style.display = 'block';	
	ResizeSCR(settW, settH);
}

function gotoMainfromSettings() {
	document.getElementById('settings').style.display = 'none';
	document.getElementById('idle').style.display = 'block';	
	ResizeSCR(idleW, idleH);	
	
	if (bNeedUpdate) LoadXMLWeatherForecast();	
}

function gotoCityPage() {
	document.getElementById('settings').style.display = 'none';
	document.getElementById('cityPage').style.display = 'block';	
	ResizeSCR(cityW, cityH);
	
	y = (2 - userSettings.cityIndex)*30;
	if (y>0) y=0;
	else if (y < offsetHeight) y = offsetHeight;	
	cityList.style.top = y+"px";	
	scrollbarPos = Math.abs(scrollbarRatio*y);	
	scroll_bar.style.top = Math.floor(scrollbarPos)+"px";	
}

function gotoUpdatePage() {
	document.getElementById('settings').style.display = 'none';
	document.getElementById('updatePage').style.display = 'block';	
	ResizeSCR(settW, settH);	
	userSettings.initUpdatePeriod();		
}

function goBacktoSettings1() {
	userSettings.saveCityIndex();	
	document.getElementById('city_name').innerHTML = towns[userSettings.cityIndex][0];	
	document.getElementById('cityPage').style.display = 'none';
	document.getElementById('settings').style.display = 'block';	
	ResizeSCR(settW, settH);				  
}

function goBacktoSettings2() {
	document.getElementById('updatePage').style.display = 'none';
	document.getElementById('settings').style.display = 'block';	
	ResizeSCR(settW, settH);
	document.getElementById('update_period').innerHTML = update_txt[userSettings.tempIndex];
	userSettings.saveUpdatePeriod();	
	userSettings.SetUpdateTimer();
}
					  

function goHomePage()
{
	openURL("http://wap.championat.ru");
}

function openURL(url)
{
	try
	{
		widget.openURL(url);
	}
	catch(e)
	{
		document.location.href = url;
	}
}

function ResizeSCR(width, height)
{
  	try
  	{
  	  widget.window.resizeWindow(width, height);
  	}
  	catch (e)
  	{
  	  //window.resizeTo(width, height);
  	}
}

showNetworkError = function()
{
	hidePopup('refresh');
	showPopup('network_error', 53, 20);
	bUpdating = false;
}
	
showAccessError = function()
{
	hidePopup('refresh');
	showPopup('access_error', 53, 20);
	bUpdating = false;
}	

function searchCityName() {
	var isFound = false;
	var n;
	var str1 = "";
	var str2 = "";
	str1 = city_input.value.toLowerCase();
	
	for (var i=0; i<towns.length; i++) {
		str2 = String(towns[i][0]).toLowerCase();
		n = str2.indexOf(str1, 0);
		if (n != -1) {
			if (n < str1.length) {
				y = (2-i)*30;
				if (y < offsetHeight) y = offsetHeight;	
				else if (y>0) y=0;
				cityList.style.top = y+"px";
				document.getElementById('tCityList').rows[userSettings.tempIndex2].style.backgroundImage = "none";
				document.getElementById('tCityList').rows[i].style.backgroundImage="url(images/cursor.png)";	
				scrollbarPos = Math.abs(scrollbarRatio*y);
				scroll_bar.style.top = Math.floor(scrollbarPos)+"px";
				userSettings.tempIndex2 = i;	
				isFound = true;				
				break;
			}
		}		
	}	
	
	if (!isFound) {
		alert(noResults);
		city_input.value = "";		
	}
	
}

function scrollUp() {
	y += 60;
	if (y > 0) y = 0;
	
	cityList.style.top = y+"px";	
	scrollbarPos = Math.abs(scrollbarRatio*y);	
	scroll_bar.style.top = Math.floor(scrollbarPos)+"px";
}


function scrollDown() {
	y -= 60;
	if (y < offsetHeight) y = offsetHeight;
	
	cityList.style.top = y+"px";	
	scrollbarPos = Math.abs(scrollbarRatio*y);	
	scroll_bar.style.top = Math.floor(scrollbarPos)+"px";
}